/*
 * eth_tx_iface.hpp
 *
 *  Created on: 13 мар. 2023 г.
 *      Author: sychev
 */

#ifndef FREE_RTOS_ETHERNET_ETH_TX_FLOW_IFACE_HPP_
#define FREE_RTOS_ETHERNET_ETH_TX_FLOW_IFACE_HPP_

#include <cstdint>
#include "free_rtos/ethernet/eth_types.h"
#include "free_rtos/handler_store/handler_store.hpp"

struct TxFlowHandlerArgs : public HandlerArgs {
    TEthMacPorts port_id;
    Handler * stack_handler;
};

class EthTxFlowIface {
public:
    virtual bool send(TEthMacPorts port_id, uint8_t * p_data, uint32_t len) = 0;
    virtual bool send(TxFlowHandlerArgs& handlerArgs, uint32_t numScatterSegments) = 0;
    virtual ~EthTxFlowIface(){}
};



#endif /* FREE_RTOS_ETHERNET_ETH_TX_FLOW_IFACE_HPP_ */
