/*
 * eth_vlan.hpp
 *
 *  Created on: 9 мар. 2023 г.
 *      Author: sychev
 */

#ifndef FREE_RTOS_ETHERNET_ETH_VLAN_HPP_
#define FREE_RTOS_ETHERNET_ETH_VLAN_HPP_

//#include "free_rtos/semaphore/semaphore.hpp"

#include <networking/enet/core/include/core/enet_base.h>
//#include <networking/enet/core/include/per/icssg.h>

#include <stdint.h>

//namespace free_rtos {
#ifdef __cplusplus
extern "C" {
#endif

int32_t eth_vlan_setPriorityRegMapping(Enet_Handle handle,
                                       uint32_t core_id,
                                       Enet_MacPort macPort,
                                       uint32_t *prioRegenMap);

int32_t eth_vlan_setPriorityMapping(Enet_Handle handle,
                                    uint32_t core_id,
                                    Enet_MacPort macPort,
                                    uint32_t *prioMap);

int32_t eth_vlan_addDefaultHostVid(Enet_Handle handle,
                                   uint32_t core_id,
                                   uint8_t pcp,
                                   uint16_t vlan_id);

int32_t eth_vlan_addDefaultPortVid(Enet_Handle handle,
                                   uint32_t core_id,
                                   Enet_MacPort macPort,
                                   uint8_t pcp,
                                   uint16_t vlanId);

int32_t eth_vlan_init(Enet_Handle handle,
                      uint32_t core_id,
                      uint16_t vlanId,
                      Enet_Type enetType);

/*int32_t eth_vlan_addMacFdbEntry(Enet_Handle handle,
                                uint32_t core_id,
                                Semaphore& ioctl_sem,
                                Icssg_MacAddr mac,
                                int16_t vlanId,
                                uint8_t fdbEntryPort);

}*/

#ifdef __cplusplus
}
#endif

#endif /* FREE_RTOS_ETHERNET_ETH_VLAN_HPP_ */
