/*
 * eth_udp_server_iface.hpp
 *
 *  Created on: 15 апр. 2023 г.
 *      Author: sychev
 */

#ifndef FREE_RTOS_ETHERNET_IP_ETH_UDP_SERVER_IFACE_HPP_
#define FREE_RTOS_ETHERNET_IP_ETH_UDP_SERVER_IFACE_HPP_

#include "free_rtos/ethernet_ip/eth_udp_client.hpp"

#include <memory>

#include <cstdint>

namespace free_rtos {

class EthUdpServerIface {
public:
    virtual std::shared_ptr<EthUpdClient> createClient(uint16_t port_dst, uint16_t port_src, bool use_chksum) = 0;
    virtual int32_t select(uint32_t ticks = SystemP_WAIT_FOREVER) = 0;

    virtual ~EthUdpServerIface() {};
};

}

#endif /* FREE_RTOS_ETHERNET_IP_ETH_UDP_SERVER_IFACE_HPP_ */
